
'**************************************************************************************************
'THIS PROGRAM INTEGRATEDS ESTIMATION AND PREDICTION 
'**************************************************************************************************

'This program includes following blocks:
' 1) VAR in differences (VECM)
' 2) VAR in levels
' 3) Bayesian VAR
' 4) Diffusion index
' 5) State space models
' 6) Exponential smoothing
' 7) Discounted LS (exponential discounting of distant observations)

%thevariable=   "dlog(rgdp_cze,0,4)" '  "d(unemplilo_cze,0,4)" '  "dlog(cpi_cze,0,4)" '      ' unemplilo_cze,0,4)"

%thevariableX="rgdp_cze"

%thesuffix="cze"

%date_global_start="1996:1"
%date_global_end="2008:2"

%date_global_forecast="2010:1"

'import data from Excel files
statusline IMPORT DATA
call IMPORT_DATA

'detrend all series
statusline DETREND SERIES
call DETREND_SERIES


'EXOGENOUS VARIABLES

%exo_global="  dummy991 dummy972 dummy973 dummy983 dummy984 dlog(ex_eurousdf) dlog(rgdp_euf) dummy96q499q4"
 

!exo_num_global=8

scalar exo_var_num=!exo_num_global

'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
'RUN TIME VARYING INTERCEPT MODELS (VARS)

call run_ss_models("1996:2", "2008:2", 2, 7, 2, "c(52)*dlog(rgdp_euf(-1))+c(53)*dlog(ex_eurousdf)",%thesuffix)


'string %start_date_SS, string %end_date_SS, scalar VAR_OrderSS, scalar SS_forec_horizon, scalar SS_exo, string %exo_transformed, string %country_suffix)


'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

!hor_BVAR_forec=@dtoo(%date_global_forecast)-@dtoo(%date_global_end)
%str_hor_BVAR_select=@otod(@dtoo(%date_global_end)-3)

call Bvar_all(3,!hor_BVAR_forec,2,!exo_num_global, %exo_global,%thesuffix,"1996:2",%str_hor_BVAR_select)


'subroutine Bvar_all (scalar horizon_selection, scalar horizon_forecasting, scalar VAR_order, scalar exo_var_num, string %exo_var_list,  string %country_suffix, string %start_date_var, string %end_date_var_selection)


if @isobject("s_bvar") then 
	delete s_bvar
endif

sample s_bvar %date_global_end+1 %date_global_forecast


if @isobject("_bvar_forec") then 
	delete _bvar_forec
endif

if @isobject("_bvar_forec_sterr") then 
	delete _bvar_forec_sterr
endif

smpl @all
delete _bvar_series*
for !bb=1 to !m
	series _bvar_series{!bb}=0
next

group _bvar_forec _bvar_series*

mtos(_endo_forec, _bvar_forec, s_bvar)

delete _bvar_strerrs*
for !bb=1 to !m
	series _bvar_strerrs{!bb}=0
next

group _bvar_forec_sterr _bvar_strerrs*

mtos(_approx_stderr, _bvar_forec_sterr, s_bvar)

statusline BVAR is up



'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$


%str_q_others_hor=@str(@dtoo(%date_global_forecast)-@dtoo(%date_global_end))
call Q_others("1994:1",%date_global_end,%thevariable,%exo_global,%str_q_others_hor,"var000","1","VAR009",%thevariableX) 

'parameters for this program 
'%0 -- starting date (string)
'%1 -- ending date (string)
'%2 -- dependent variable, like  "dlog(rgdp_czh,0,4)"
'%3 -- exogenous variables
'%4 -- forecast horizon
'%5 -- var as a baseline
'%6 -- extra sample for smoothing 
'%7 -- raw name of the variable

statusline Q_others_is_done



'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

statusline Diffusion index

%exo_dif_ind= "  dlog(ex_eurousdf) dlog(rgdp_euf)" 

!diff_index_hor=@dtoo(%date_global_forecast)-@dtoo(%date_global_end)

%dat_diff_index1=@otod(@dtoo(%date_global_end))
call diff_index(%thevariable,%exo_dif_ind,"1998:1", %dat_diff_index1,%thesuffix, !diff_index_hor,%thevariableX)


statusline Diffusion index is done
smpl @all

'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

' Do discounted least squares
statusline DISCOUNTED
'call pickname(%thevariable,%thevariable1)

%exo_disc_LS=%exo_dif_ind

call DISCOUNT_LS(%thevariable,%date_global_end,%date_global_forecast,%exo_disc_LS,%thevariableX)

'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

'compute forecasts based on EIU forecasts

call  EIU_forecs


'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

'compute forecasts based on EIU forecasts

call  OECD_forecs


'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

'ALL COMPUTATIONS ARE COMPLETED
'POOL FORECASTS





%str_tt=%date_global_end+" "+%date_global_forecast
smpl {%str_tt }
'2002:4 2004:4

'point forecasts
group all_forecs zzz group1_DI _bvar_forec {%thevariableX}_SS  {%thevariableX}_eiu  {%thevariableX}_wls {%thevariableX}_oecd

show all_forecs

'standard errors
group all_forec_SE zzz_se group2_DI_SE _bvar_forec_sterr {%thevariableX}_SS_SE {%thevariableX}_eiu_se {%thevariableX}_wls_se {%thevariableX}_oecd_se

show all_forec_SE

delete ser*
'delete df_pc
delete add_*
delete sv*
delete ss*
delete s_bvar*
delete m0* v0*

delete y y_pcs zzz* '_*  *sa *sf  *_0* *_1*  *eiu*  '*_a  

delete *temp*

'delete test* sort*

statusline OK


'**************************************************************************************************
'**************************               END OF MAIN BODY   *******************************
'**************************************************************************************************



'**************************************************************************************************
'**************************               START OF SUBROUTINES     ************************
'**************************************************************************************************

SUBROUTINE Q_others(string %0, string %1, string %2, string %3, string %4, string %5, string %6, string %7, string %8)

'parameters for this program 
'%0 -- starting date (string)
'%1 -- ending date (string)
'%2 -- dependent variable, like  "dlog(rgdp_czh,0,4)"
'%3 -- exogenous variables
'%4 -- forecast horizon
'%5 -- var as a baseline (in DIFFRECENS)
'%6 -- extra sample for smoothing 
'%7 -- var as a baseline (in LEVELS)


'set of exogenous variables
'%exo="dummy991 dummy973 dlog(ex_eurousdf) dlog(rgdp_euf,0,4) "
%exo=%3 '        "dummy991 dummy973 dlog(ex_eurousdf) dlog(rgdp_euf) "

'dependent variable
%dep=%2 '   "dlog(rgdp_czh,0,4)"

'starting date
'%0="1993:1"

'end date
'%1="2002:2"

'forecasting horizon
!horizon=@val(%4)

%str_hor=%4

'enter VAR model to analyze
'for slovenia, russia and ukraine "var01_1"
'for bulgaria var04
%2_var=%5 '           "var01"
%7_var=%7 '           e.g. "var009"

'raw name of the variable
%str_ser=%8

'extra sample for smoothing
!extra_smooth=@val(%6)

'intercept correction
'horizon for residuals to look at
!back_hor=3 'was 3
%00=@otod(@dtoo(%1)-!back_hor)

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'PRINCIPAL COMPONENTS BLOCK

!saze=@dtoo(%1)-@dtoo(%0)

'find the name of the variable
'call pickname(%dep,%str_ser)
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

' VAR BLOCK

smpl %0 %1 

if @isobject(%2_var+"x") then
	delete {%2_var}x
endif

if @isobject(%7_var+"x") then
	delete {%7_var}x
endif

copy {%2_var}  {%2_var}x
copy {%7_var}  {%7_var}x

'I need to make sure that I estimate VAR on the specified sample

'preprare forecast for a model in levels
statusline VAR in levels

if @isobject("model_L") then
	delete model_L
endif



{%7_var}.makemodel(model_L)

'set  active scenario
model_L.scenario "Scenario 1"
'intecept shifts (corrections)
'set solve options
model_L.solveopt(s=s, d=d,i=a)
smpl {%1}+1 {%1}+!horizon '{%str_hor}
model_L.solve

'------------------

'standard forecasts

statusline VAR in differences
if @isobject("model_no_ic") then
	delete model_no_ic
endif

{%2_var}.makemodel(model_no_ic)
model_no_ic.scenario baseline
model_no_ic.solveopt(s=s, d=d,i=a)
'model_no_ic.addinit(v=z) @stochastic
model_no_ic.solve(f=na)

'call pickname(%dep,%str_serX)

'statusline  %str_ser %sername

statusline %str_ser
smpl @first {%1}
series  {%str_ser}_sa_1m=na
series  {%str_ser}_0m=na


smpl @all

statusline Exponential smoothing
call smoothing_w_se(%str_ser, %0,%1)

'~~~~~~~~~~~~~~~~~~~~~

smpl %1-4 %1+!horizon
'PREPARE FORECASTS FOR EXPORT

'call pickname(%dep,%str_ser)

'g 
'write(t=xls) c:\forecasts.xls  {%str_ser} {%str_ser}f {%str_ser}FIC  {%str_ser}_0m  {%str_ser}_sa_1m {%str_ser}FICM
'baseline scenario has not intercept correction

smpl @all

'point forecasts
series {%str_ser}_VAR={%str_ser}_0m 
series {%str_ser}_VAR_L={%str_ser}_sa_1m*{%str_ser}_sf
series {%str_ser}_smooth=_x_ra

'standard errors

series {%str_ser}_VARs={%str_ser}_0s 
series {%str_ser}_VAR_Ls={%str_ser}_SA_1s
series {%str_ser}_s_s=_x_ra_se


group zzz  {%str_ser}_VAR {%str_ser}_VAR_L  {%str_ser}_smooth

group zzz_se {%str_ser}_VARs {%str_ser}_VAR_Ls  {%str_ser}_s_s

delete x*

delete resid* exo_var_num 

smpl %0 %1+!horizon

endsub


'===========================================
'subroutine to pick the name of the variable

subroutine pickname(string %sername, string %netname)

%netname=%sername

if @left(%sername,5)="DLOG(" then 
			!j1=0
			!j2=0
			while !j2=0 
				!j1=!j1+1
				if @mid(%sername,!j1,1)="," or @mid(%sername,!j1,1)=")" then 
						!j2=!j1
				endif
			wend
			%netname=@mid(%sername,6,!j2-6)
	endif

	if @left(%sername,2)="D(" then 
			!j1=0
			!j2=0
			while !j2=0 
				!j1=!j1+1
				if @mid(%sername,!j1,1)="," or @mid(%sername,!j1,1)=")" then 
						!j2=!j1
				endif
			wend
			%netname=@mid(%sername,3,!j2-3)
	endif

	if @left(%sername,4)="LOG(" or @left(%sername,4)="log(" then 
			!j1=4
			!j2=6
			while !j2=0 or !j1>@strlen(%sername)
				!j1=!j1+1
				if @mid(%sername,!j1,1)="," or @mid(%sername,!j1,1)=")" or @mid(%sername,!j1,1)="(" then 
						!j2=!j1
				endif
			wend

			%netname=@mid(%sername,5,!j2-5)


	endif
	

endsub

'------------------------------------------------------------
'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

subroutine smoothing_w_se(string %var1, string %xx00, string %xx01)

'%xx00 start date
'%xx01 end date 
'%var1="_czh"

%depvar1="log("+%var1+")"
'strating observation

'%0="1995:1"

'last know date
'%1="2000:4"

'!horizon=4

smpl @first %xx01

'smpl %0 %1
if @isobject("_x") then
	delete _x
endif

genr _x=log({%var1})

smpl %xx00 %xx01+!extra_smooth


'smooth(n,e,e) _x  _x_04a

smooth(a,e,e,e) _x  _x_04a

smpl @all

genr _x_ra=exp(_x_04a)

smpl @all

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'compute standard errors

'assume that the largest coeffecint is 0.9
!teta1=0.9
!v1=1-!teta1
'5% confidence interval
!z=1.96

'compute mean abs error
smpl %xx00 %xx01
genr error1=abs(exp({%depvar1})-(_x_ra))
!mae=@mean(error1)


if @isobject("_x_ra_se") then
	delete _x_ra_se
endif

for !i=1 to !horizon
smpl %xx01+!i %xx01+!i
series _x_ra_se=1.25*!z*!mae*((1+!teta1/(1+!v1)^3*(1+4*!v1+5*!v1^2)+2*!teta1*(1+3*!v1)*!i+2*!teta1^2*!i^2)/(1+!teta1/(1+!v1)^3*(1+4*!v1+5*!v1^2)+2*!teta1*(1+3*!v1)+2*!teta1^2))^0.5

next

'smpl %xx00 %xx01+!horizon
'show _x_ra _x_ra_se


endsub




'**************************************************************************************************
' ***************************************   BAYESIAN BLOCK   *******************************
'**************************************************************************************************

subroutine Bvar_all (scalar horizon_selection, scalar horizon_forecasting, scalar VAR_order, scalar exo_var_num, string %exo_var_list,  string %country_suffix, string %start_date_var, string %end_date_var_selection)

'starting date
'%0="1995:1"
%0=%start_date_var

'end date
'%1="2000:4"
%1=%end_date_var_selection

'forecast horizon for model selection
'!h=4
!h=horizon_selection

'"REAL" forecast
'!hh=4
!hh=horizon_forecasting

'tightness lambda
!lambda=3

'speed of decay
!teta=0.9

'order of the VAR
'!p=2
!p=VAR_order

'number of endogenosu variables
!m=5
'!m=endo_var_num

'number of exogenous variables
'!exovar=2
!exovar=exo_var_num

'set of exognous variables
'%exoF="dlog(rgdp_euf) dlog(ex_eurousdf,0,4)" ' dummy991"
%exoF=%exo_var_list

'set of endogenous variables
'%suf="_hun"
%suf="_"+%country_suffix


%endo_v1="rgdp"+%suf
%endo_v2="unemplilo"+%suf
%endo_v3="cpi"+%suf
%endo_v4="exeuro"+%suf
%endo_v5="m2"+%suf

'+++++++++++++++++++++++++++++++++++++++++++++
'Define strings for endogenous variables and their lags



%endoF="dlog("+%endo_v1+",0,4) d("+%endo_v2+") dlog("+%endo_v3+",1,4) dlog("+%endo_v4+",1,4) dlog("+%endo_v5+")"
%endo1F=" "
%endo2F=" "
%endo3F=" "
%endo4F=" "


if !p>=1 then 

	%endo1F="dlog("+%endo_v1+"(-1),0,4) d("+%endo_v2+"(-1)) dlog("+%endo_v3+"(-1),1,4) dlog("+%endo_v4+"(-1),1,4) dlog("+%endo_v5+"(-1))"

endif

if !p>=2 then 
	%endo2F="dlog("+%endo_v1+"(-2),0,4) d("+%endo_v2+"(-2)) dlog("+%endo_v3+"(-2),1,4) dlog("+%endo_v4+"(-2),1,4) dlog("+%endo_v5+"(-2))"
endif

if !p>=3 then 
	%endo3F="dlog("+%endo_v1+"(-3),0,4) d("+%endo_v2+"(-3)) dlog("+%endo_v3+"(-3),1,4) dlog("+%endo_v4+"(-3),1,4) dlog("+%endo_v5+"(-3))"
endif

if !p>=4 then
	%endo4F="dlog("+%endo_v1+"(-4),0,4) d("+%endo_v2+"(-4),0,4) dlog("+%endo_v3+"(-4),0,4) dlog("+%endo_v4+"(-4),0,4) dlog("+%endo_v5+"(-4),0,4)"
endif

'++++++++++++++++++++++++++++++++++++++++++++

scalar Check=1e6
scalar check_lambda=0
scalar check_teta=0

matrix(1000,100) checks
checks.fill(L) 0

matrix(!m,!m) Bprior
Bprior.fill(L) 0
Bprior(1,1)=1
Bprior(2,2)=1
Bprior(3,3)=1
Bprior(4,4)=1
Bprior(5,5)=1

'vectorize the matrix of priors appropriately
vector((!m*!p+!exovar+1)*!m) Bprior_vec
Bprior_vec.fill(L) 0
'fill the vector with priors
for !i=1 to !m
		Bprior_vec((!i-1)*(!m*!p+!exovar+1)+!i)=Bprior(!i,!i)
next

for !param_lambda=2 to 2  step 1
	for !param_teta=0.15 to 0.95 step 0.05
		statusline Lambda: !param_lambda     Tetha: !param_teta
		call BVAR(%exoF, !param_lambda , !param_teta ,!exovar,!p ,5 ,%0 ,%1 ,%endoF, %endo1F , %endo2F,%endo3F,%endo4F)

'subroutine BVAR (string %exo_1, scalar tight_lambda, scalar decay_teta, scalar N_exovar, scalar VAR_order, scalar N_endovar, string %start_smpl, string %end_smpl, string %endo, string %endo_1, string %endo_2, string %endo_3, string %endo_4)


		call bvar_forec(!h, bvar, %1)
		call BVAL_eval(!h, %endoF, endo_for)
		checks(!param_lambda,@round(!param_teta*10))=theil
		if Theil<check then 
			check=theil
			check_lambda=!param_lambda
			check_teta=!param_teta
		endif
	next
next

		'compute final estimates for model selection 
		call BVAR(%exoF, check_lambda , check_teta ,!exovar ,!p ,5 ,%0 ,%1 ,%endoF, %endo1F , %endo2F," "," ")
		call bvar_forec(!h, bvar,%1)

'subroutine conf_bounds (scalar VARorderB, scalar !boot_horizon) 
matrix(!m,!hh) lower_bound
lower_bound.fill(L) 0

matrix(!m,!hh) upper_bound
upper_bound.fill(L) 0

matrix(!m,!hh) approx_stderr
approx_stderr.fill(L) 0

'MAKE FINAL ESTIMATES
'		%new_end=@otod(@dtoo(%1)+!hh-1)
		%new_end=@otod(@dtoo(%1)+!h-1)

		call BVAR(%exoF, check_lambda , check_teta ,!exovar ,!p ,5 ,%0 ,%new_end ,%endoF, %endo1F , %endo2F,%endo3F,%endo4F)

statusline Bootstap standard errors for BVAR
'store confidence bounds for each horizon
call confidence_bounds(5,!hh,%new_end)


for !kkk=1 to !hh


	for !iii=1 to !m
		lower_bound(!iii,!kkk)=conf_bounds(!kkk,2*(!iii-1)+1)
		upper_bound(!iii,!kkk)=conf_bounds(!kkk,2*(!iii-1)+2)
		'approximate standard error
		approx_stderr(!iii,!kkk)=(upper_bound(!iii,!kkk)-lower_bound(!iii,!kkk))/4
	next	
next

'delete conf_bounds
	
'====================================================================

'estimate the BVAR model  for the best regression
		
		'%new_end=@otod(@dtoo(%1)+!hh)
		%new_end=@otod(@dtoo(%1)+!h)

		call BVAR(%exoF, check_lambda , check_teta ,!exovar ,!p ,5,%0 ,%new_end ,%endoF, %endo1F , %endo2F,%endo3F,%endo4F)
		call bvar_forec(!hh, bvar,%new_end)

		call BVAR(%exoF, 0.99 , 100000 ,!exovar ,!p ,5 ,%0 ,%new_end ,%endoF, %endo1F , %endo2F,%endo3F,%endo4F)


		matrix(1,1) _endo_forec=endo_for
		matrix(1,1) _bvar=bvar
		matrix(1,1) _approx_stderr=@transpose(approx_stderr)
		matrix(1,1) _bvar_post=vpost
		matrix(1,1) _lower_bound=lower_bound
		matrix(1,1) _upper_bound=upper_bound
		matrix(1,1) _bprior=bprior
		matrix(1,1) _bvarcov=bvarcov
		matrix(1,1) _check_teta=check_teta
		matrix(1,1) _check_lambda=check_lambda
		

'====================================================================

'clean redundant matrices
delete theil check check_lambda check_teta bprior_vec
delete x_mat_f vpost alpha_bar  bvarcov bprior lower_bound upper_bound approx_stderr bvar endo_for 
delete residsvar varcoef x exof_mat exof endo_v

endsub

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
subroutine BVAR (string %exo_1, scalar tight_lambda, scalar decay_teta, scalar N_exovar, scalar VAR_order, scalar N_endovar, string %start_smpl, string %end_smpl, string %endo, string %endo_1, string %endo_2, string %endo_3, string %endo_4)




'tightness lambda
!lambda=tight_lambda

!teta=decay_teta

%exo=%exo_1
%endo1=%endo_1
%endo2=%endo_2
%endo3=%endo_3
%endo4=%endo_4

'start sample
'%0=%start_smpl
'end sample
'%1=%end_smpl

'number of endogenosu variables
!m=N_endovar

'number of exogenous variables
!exovar=N_exovar

%x=%endo1+%endo2+%exo+" c"

if @isobject("x") then
	delete x
endif
group x {%x}

if @isobject("endo_v") then
	delete endo_v
endif

group endo_v {%endo}

if @isobject("s_bvar_stom") then
	delete s_bvar_stom
endif

if @isobject("x_mat") then
	delete x_mat
endif

if @isobject("endo_mat") then
	delete endo_mat
endif


sample s_bvar_stom %start_smpl %end_smpl

'convert series into matrices

smpl %start_smpl %end_smpl

stom(endo_v,endo_mat,s_bvar_stom)

smpl %start_smpl %end_smpl
stom(x,x_mat,s_bvar_stom)

'Necesary if dataset is incomplete
'matrix endo_mat_temp=@subextract(endo_mat,!p+1,1)
'matrix endo_mat=endo_mat_temp
'delete endo_mat_temp

'generate the vector of ones
smpl @all
series ones=1

if @isobject("var_xx") then
	delete var_xx
endif

'estimate variance to get 1st stage estimates of covariances
smpl %start_smpl %end_smpl
var var_xx.ls 1 !p  {%endo} @ ones {%exo}

matrix(1,1) varcov=var_xx.@residcov
matrix(1,1) varcoef=var_xx.@coefmat	
matrix(1,1) varcoef1=var_xx.@coefmat	


'put coefficients in the "by lag" order 
for !i=1 to !m
	for !k=1 to !m
		for !j=1 to !p
			varcoef1((!j-1)*!m+!k,!i)=varcoef((!k-1)*!p+!j,!i)
		next
	next
next

varcoef=varcoef1
delete varcoef1

if @isobject("Litterman") then
	delete Litterman
endif

'This is the matrix V_alpha (Lutkepohl, p 209)

matrix((!m*!p+!exovar+1)*!m,(!m*!p+!exovar+1)*!m) Litterman
Litterman.fill(L) 0

'fill in priors
for !j=1 to !p
	for !i=1 to !m
		for !k=1 to !m
			if !i=!k then 
				Litterman((!j-1)*(!m)^2+(!i-1)*!m+!i,(!j-1)*(!m)^2+(!i-1)*!m+!i)=(!lambda/!j)^2
			endif
			if !i<>!k then
				Litterman((!j-1)*(!m)^2+(!i-1)*!m+!k,(!j-1)*(!m)^2+(!i-1)*!m+!k)=(!lambda*!teta/!j)^2*(varcov(!k,!k)/varcov(!i,!i))
			endif
		next
	next
next


'set free priors for exogenous variable, i.e. lambda equal to plus infiniti
for !j=1 to (!exovar+1)*!m
	Litterman(!m^2*!p+!j,!m^2*!p+!j)=(!lambda+0.1)*(1e5)
next

'compute bayesian estimates
matrix x_mat_a=x_mat
matrix zzz00=@kronecker(@inverse(varcov),@transpose(@subextract(x_mat,1,1,@rows(x_mat),!m*!p+!exovar+1))*@subextract(x_mat,1,1,@rows(x_mat),!m*!p+!exovar+1))

matrix zzz01=@inverse(Litterman)+zzz00
matrix zzz02=@inverse(zzz01)
'matrix zzz03=@vec(@subextract(endo_mat, !p+1,1))

matrix zzz03=@vec(endo_mat)
matrix zzz04=@kronecker(@inverse(varcov),@transpose(x_mat))

'stacked coefficeints for BVAR model
matrix alpha_bar=zzz02*(@inverse(Litterman)*Bprior_vec+zzz04*zzz03)

'combine Bayesian vector estimates into matrix
matrix(@rows(varcoef),@columns(varcoef)) Bvar
Bvar.fill(L) 0

for !i=1 to !m
	matplace(Bvar,@subextract(alpha_bar,(!i-1)*(!m*!p+!exovar+1)+1,1,!i*(!m*!p+!exovar+1),1),1,!i)
next

'compute residuals
matrix(1,1) residsvar=endo_mat-x_mat*Bvar

'compute covaraince matrix of the residuals
matrix(1,1) Bvarcov=@cov(residsvar)

'posterior covaraince matrix
sym(1,1) Vpost=zzz02


delete litterman endo_mat
delete varcov 'varcoef* 
delete zzz* xxx0*
'delete alpha_bar
'delete x_mat_a x_mat

endsub

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`

subroutine bvar_forec (scalar horizon, matrix BVAR1, string %start_date_forec)
'compute forecasts for the BAyesian VAR model 

!h_forec=horizon


'pick exogenous variables
smpl %start_date_forec+1 %start_date_forec+!h_forec
if @isobject("exof") then
	delete exof
endif
group exof {%exo} ones


stom(exof,exof_mat)

'pick initial values
smpl %start_date_forec-!p+1 %start_date_forec 
stom(endo_v,x_mat_f)

matrix(1,1) m_mat_f1=x_mat_f
'define the matrix of forecasts
matrix(!h_forec,!m) endo_for
endo_for.fill(L) 0

'compute forecasts

for !i=1 to !h_forec
	matrix(1,!m*!p+!exovar+1) exo_forec
	exo_forec.fill(L) 0

	'fill the matrix of predetermined variables into matrix exo_forec 
	for !j=1 to !p
		matplace(exo_forec,@subextract(x_mat_f,!p-!j+1,1,!p-!j+1,!m),1,!m*(!j-1)+1)
	next
	
	'place exogenous variables
	matplace(exo_forec,@subextract(exof_mat,!i,1,!i,!exovar+1),1,!m*!p+1)
	
	'compute the forecast
	matplace(endo_for,exo_forec*Bvar1,!i,1)
	
	'shift the set of predermined variables by one in the matrix of predetmined variables. 
	for !j=1 to !p-1
		matplace(x_mat_f,@subextract(x_mat_f,!j+1,1,!j+1,!m),!j,1)
	next

	'replace the first row of lagged dependent variables with compuited values.
	matplace(x_mat_f, exo_forec*Bvar1,!p,1)

next

delete m_mat_f1 exo_forec

endsub

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

subroutine confidence_bounds (scalar VARorderB, scalar boot_horizon, string %start_date_boot) 

'only the last period bootstrap is saved

'set # of iterations for parametric bootstrap
!boot=200

'lower bound
!lb=0.05
'upper bound
!ub=0.95

'define temporary matrix to store bootstrap iterations
for !z_hor=1 to boot_horizon
matrix(VARorderB,!boot) temp_boot{!z_hor}
temp_boot{!z_hor}.fill(L) 0
next

'start bootstrap
	for !ib=1 to !boot
		'randomly draw posterior distributions: parametric bootstrap
		vector(VAROrderB*(VARorderB*!p+!exovar+1)) shocks
		shocks.fill(L) 0
			for !jb=1 to VAROrderB*(VARorderB*!p+!exovar+1)
				shocks(!jb)=@rnorm
			next
		
		matrix(1,1) BVAR_BOOT_stacked=alpha_bar+@cholesky(Vpost)*shocks

		'combine Bayesian vector estimates into matrix
		matrix(@rows(varcoef),@columns(varcoef)) Bvar_boot
		Bvar_boot.fill(L) 0

		for !ib2=1 to VAROrderB
			matplace(Bvar_boot,@subextract(BVAR_BOOT_stacked,(!ib2-1)*(!m*!p+!exovar+1)+1,1,!ib2*(!m*!p+!exovar+1),1),1,!ib2)
		next

		'produce forecast
		call bvar_forec(boot_horizon,BVAR_BOOT,%start_date_boot)	
		
		'store values
		for !jbt=1 to VARorderB
			for !z_hor=1 to boot_horizon
				temp_boot{!z_hor}(!jbt,!ib)=endo_for(!z_hor,!jbt)
			next
		next

next
	
'pick perceptiles
'this matrix is returned with 95% confidence bounds

	matrix(boot_horizon,VarorderB*2) conf_bounds
	conf_bounds.fill(L) 0



for !z_hor=1 to boot_horizon
	'Assume that VAR order is always 5
	Statusline BVAR confidence bounds Horizon: !z_hor
	
		'sort using axillialry file		
		'pick percentiles

		for !sort_1=1 to VarorderB
			
			matrix sort_t=@transpose(temp_boot{!z_hor})

			sort_t.write(t=txt, nonames) c:\temp_res_mat.csv 
		
			create c:\wdi\test_me u 1 !boot

			read(t=txt) c:\temp_res_mat.csv ser_01 ser_02 ser_03 ser_04 ser_05

			sort ser_0{!sort_1} 

			!upper=ser_0{!sort_1}(@round(!ub*!boot))
			!lower=ser_0{!sort_1}(@round(!lb*!boot))
			scalar x1=!upper
			scalar x2=!lower
		
			close test_me

			conf_bounds(!z_hor,(!sort_1-1)*2+1)=!lower
			conf_bounds(!z_hor,(!sort_1-1)*2+2)=!upper
				


		next


next



'matrix(1,1) temp1=@transpose(temp_boot)

delete shocks bvar_boot bvar_boot_stacked temp_b* 'temp1

endsub

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
subroutine BVAL_eval(scalar horizon, string %endo, matrix forecs)
'this subroutine evaluates perfromance of ex ante forecasts. 
!h=horizon


smpl %1+1 %1+!h
if @isobject("zzzz") then
	delete zzzz
endif
group zzzz {%endo}

stom(zzzz, endo_ante)

matrix(1,1) resids_ante=(endo_ante-forecs)

scalar Theil=0

for !i=1 to @rows(endo_ante)
	for !j=1 to @columns(endo_ante)
		Theil=Theil+@sumsq(@subextract(resids_ante,1,!j,@rows(endo_ante),!j))/(@sumsq(@subextract(endo_ante,1,!j,@rows(endo_ante),!j))+@sumsq(@subextract(forecs,1,!j,@rows(endo_ante),!j)))

	next
next

delete resids_ante endo_ante

endsub



'**************************************************************************************************
'***********************  'SUBROUTINES FOR PRINCIPAL *********************************
'*********************    COMPONENTS ANALYSIS (DIFFUSION)  ************************
'**************************************************************************************************

subroutine diff_index(string %dep, string %exo, string %0, string %1, string %suf, scalar diff_hor, string %2)

'THIS PROGRAM IMPORT DATA FROM EXCEL FILE AND THEN COMPUTES FORECASTS
'BASED ON DIFFUSION INDEX THEORY

'set of exogenous variables

'%exo="dlog(rgdp_euf) dlog(ex_eurousdf,0,4)"
'%dep="dlog(rgdp_bul,0,4)"



'starting date
'%0="1994:1"

'end date
'%1="2002:2"

'country suffix
'%suf="bul"

'forecasting horizon
!horizon=diff_hor '
'!h=6

smpl @all
smpl %0 %1
'find the name of the variable
%str_ser=%2


'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'DOWNLOAD SERIES FROM EXCEL FILE
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
smpl @all

%suf_temp=%suf
'path to the file and file name
%str_path="C:\final2cd\description\DATA\diffusion\"+%suf_temp+".xls"

read(t.xls,letter_number=B2, s={%suf}) %str_path 500

delete ser??? ser?? ser?

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' ESTIMATE PRINCIPAL COMPONENTS
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

!samplesize=@dtoo(%1)-@dtoo(%0)

'---------
'group series for diffusion index 

	if @isobject("xxx") then
		delete xxx
	endif 

group xxx series_{%suf}_*
!sernum=xxx.@count


smpl %0 %1
group df_pc

if @isobject("adfsample1") then
	delete adfsample1
endif

sample adfsample1 %0 %1

if @isobject("adfsample2") then
	delete adfsample2
endif

sample adfsample2 %0 %1-8


for !i1=1 to !sernum-2
statusline !i1

	'check missing values
	smpl %0 %1
	

		!flag1=0
		!flag2=0
		'Check for negative and missing values
		smpl %0-4 %1
		series x{!i1} = (series_{%suf}_{!i1} = NA)	

'		smpl %0 %0
		scalar test_adf_z=x{!i1}(@dtoo(%0))

		smpl @all
		
		scalar num_var{!i1}=0
		smpl %0-4 %1
		if @mean(x{!i1})=0 and test_adf_z=0 then 
			stom(series_{%suf}_{!i1},tempadf,adfsample1)
			stom(series_{%suf}_{!i1},tempadf2,adfsample2)
			
			scalar num_var{!i1}_z1=@var(tempadf)
			scalar num_var{!i1}_z2=@var(tempadf2)
			
			scalar num_var{!i1}=num_var{!i1}_z2
			if num_var{!i1}_z1<num_var{!i1}_z2 then 
				 scalar num_var{!i1}=num_var{!i1}_z1
			endif 

		endif

		if @sum(x{!i1})=0 and num_var{!i1}>0 then 
			smpl %0-4 %1
			'check for zero values
			series xx{!i1} = (series_{%suf}_{!i1} <= 0)	
			smpl @all
			!zzz=@sum(xx{!i1})
			


			'*********************************
			'part for LOG series
			if !zzz=0 then 
					
				'check stationarity
				scalar adf_ok=0
				smpl %0 %1
				%str_adf1="dlog(series_"+%suf+"_"+@str(!i1)+",0,4)"
				'zzz1.add %str_adf1
				call check_ADF(%str_adf1,adf_ok)

				'check if Dickey-Fuller test indicates that series is stationary
				if adf_ok=0 then 
					df_pc.add dlog(series_{%suf}_{!i1},0,4)
				endif
				
				'If series is not stationary, difference it extra time
				if adf_ok>0 then 
					df_pc.add dlog(series_{%suf}_{!i1},1,4)
				endif

			endif
			'*****************************************
			
			'part for simple difference series
			if !zzz>0 then 
				'check stationarity
				scalar adf_ok=0
				smpl %0 %1
				%str_adf1="d(series_"+%suf+"_"+@str(!i1)+",0,4)"
				call check_ADF(%str_adf1,adf_ok)

				'check if Dickey-Fuller test indicates that series is stationary
				if adf_ok=0 then 
					df_pc.add d(series_{%suf}_{!i1},0,4)
				endif
				
				'If series is not stationary, difference it extra time
				if adf_ok>0 then 
					df_pc.add d(series_{%suf}_{!i1},1,4)
				endif

			endif
			'*************************************

			
		endif
	delete x*
next

delete num* adf*

smpl %0 %1

df_pc.pcomp pc1 pc2 pc3 pc4 pc5 'pc6 pc7 pc8 pc9
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'END OF PC ESTIMATION
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

'define equations, estimate and forecast
for !i=1 to !horizon
	smpl @all
	genr y_pcs={%dep}

	smpl %0 %1
	%str1="eq00"+@str({!i})
	if @isobject(%str1) then 
		delete eq00{!i}
	endif

	equation eq00{!i} 
	eq00{!i}.ls {%dep} c pc1(-{!i}) pc2(-{!i}) pc3(-{!i}) pc4(-{!i}) pc5(-{!i}) y_pcs(-{!i}) {%exo}

'	eq00{!i}.ls {%dep} c pc1(-{!i}) pc2(-{!i}) pc3(-{!i}) pc4(-{!i}) pc5(-{!i}) ar({!i}) {%exo}
	'forecast
	%str_dat=@str(@val(%1)+!i)

	smpl %1+1 %1+!i

	%forecastser=%str_ser+"f"+@str({!i})

	if @isobject("xxx") then
		delete xxx
	endif 


	'compute unadjusted (no intercept correction) forecast 
	eq00{!i}.forecast(f=na,s) {%forecastser} {%forecastser}_se


'----------------------------------------------------------------------------------------

	'compute intercept corected forecast
'	%str_001=%1+"-4"
	%str_001=@otod(@dtoo(%1)-4)

	%str_002="eq00"+@str(!i)
statusline {%str_002}
	call ic_cor(%0,%1,%str_001,%1,%str_002,@str(!horizon),%str_ser,%dep)

		'PARAMETERS OF THE MODEL
		'starting date
		'%x0="1994:1"
		'end
		'%x1="2000:4"
		'correction sample
		'start
		'%x2="2000:1"
		'end
		'%x3="2000:4"
		'equation name
		'%x4="eq001"
		'forecast horizon
		'%x5="4"

		!horizon1=@val(%x5)
		'name of the dependant variable
		'%x6="cpi_HUN"

statusline wrong2 !i1
next
statusline wrong3
'-------------------------------------------------------------------------

'compute St.Error for diffusion index projection

'add suffix
%str_suf=@left(%str_ser, @length(%str_ser)-4)

'--------

'get the pooled forecast series
smpl @all
statusline wrong2.4

'--------

'point forecasts
%str1=%str_ser+"f"
%str1ic=%str_ser+"fic"
series {%str1}={%str1}1
series {%str1ic}={%str1ic}01
statusline wrong2.5
'-------------------------------------------------------------------------
'standard errors
series {%str1}_se={%str1}1_se
series {%str1ic}_se={%str1ic}01_se

'-------------------------------------------------------------------------
'compute

statusline wrong2.6
for !i=1 to !horizon
	smpl %1+!i %1+!i

	series {%str1}={%str1}{!i}

	series {%str1}_se={%str1}{!i}_se
if !i<10 then	
	series {%str1ic}={%str1ic}0{!i}
	series {%str1ic}_se={%str1ic}0{!i}_se
else 
	series {%str1ic}={%str1ic}{!i}
	series {%str1ic}_se={%str1ic}{!i}_se 
endif

next

'present the forecast


'smpl %0 %1+!horizon

if @isobject("group1") then 
	delete group1
endif

'-------------------------------------------------------------------------
'delete preliminary forecasts

statusline wrong2.1
for !i=1 to !horizon 
	%forecastser=%str_ser+"f"+@str({!i})

	%forecastserse=%str_ser+"f"+@str({!i})+"_se"

if !i<10 then	
	%forecastserfic=%str_ser+"fic0"+@str({!i})
	%forecastserficse=%str_ser+"fic0"+@str({!i})+"_se"
else 
	%forecastserfic=%str_ser+"fic"+@str({!i})
	%forecastserficse=%str_ser+"fic"+@str({!i})+"_se"
endif

	delete {%forecastser} {%forecastserfic} {%forecastserficm} {%forecastserse} {%forecastserficse}
statusline wrong2.2
next
'-----------

smpl @all

'point forecasts 
series {%str_ser}_DI={%str_ser}
series {%str1}_DI={%str1}
series {%str_ser}fic_DI={%str_ser}fic

statusline wrong2.3
'standard errors
series {%str1}_DI_se={%str1}_se
series {%str_ser}_DI_fic_se ={%str_ser}fic_se 


'group group1_DI %str_ser {%str1} {%str_ser}fic
group group1_DI {%str1}_DI {%str_ser}fic_DI

'group1_DI.line 

'group group2_DI_SE {%str1}_se {%str_ser}fic_se 
group group2_DI_SE {%str1}_DI_se {%str_ser}_DI_fic_se 
'show group2_DI_SE


delete series_*
endsub


'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
subroutine ic_cor(string %x0, string %x1, string %x2, string %x3, string %x4, string %x5, string %x6, string %x7)
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

'subroutine to compute intercept correction
'for a single equation

			'PARAMETERS
			'sample estimate
			'starting date
			'%x0="1994:1" (example)
			'end
			'%x1="2000:4" (example)
			'correction sample
			'start
			'%x2="2000:1" (example)
			'end
			'%x3="2000:4" (example)
			'equation name
			'%x4="eq001" (example)
			'forecast horizon
			'%x5="4" (example)
			!horizon1=@val(%x5)
			'name of the dependant variable
			'%x6="cpi_hun" (example)
			'the name of the variable in the regression
			'%x7="DLOG(cpi_hun,0,4)" (example)
			
%str_004=@right(%x4,2)

'the main body of the code

	if @isobject("xxx") then
		delete xxx
	endif 

smpl @all


{%x4}.makeresids xxx



smpl %x2 %x3

statusline wrong4

scalar ic{%str_004}=@mean(xxx)

	smpl %x1+1 %x1+!horizon1+1

	'make model from equation
	%str_model1="model00"+%str_004

	if @isobject(%str_model1) then
			delete {%str_model1}
	endif 
	{%x4}.makemodel({%str_model1})

			'create add factors
			smpl @all '%x1+1 %x1+!horizon1+1
			%str_model2="add_"+ %str_004
			if @isobject(%str_model2) then
					delete %str_model2
			endif 
			series {%str_model2}=ic{%str_004}

	'add add-factros to the model
	%str_addfactor="@add(v) "+%x6+" "+%str_model2

	{%str_model1}.append {%str_addfactor}

			'solve the model
			!horizon2=@val(%str_004)
			smpl %x1+1 %x1+!horizon2
statusline wrong5
			'solve the model
			{%str_model1}.solve(d=d,s=s)
			
			series {%x6}fic{%str_004}={%x6}_0m

	'name forecast series
	%forecaster1=%x6+"fic"+%str_004
	series {%forecaster1}_se={%x6}_0s

		if @isobject("xxx") then
			delete xxx
		endif 
	scalar _zzz=@val(@right(%x4,1))

	delete {%str_model1}
	delete ic{%str_004}

endsub

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
subroutine check_ADF(string %depvar_adf, scalar differencing)

'smpl %0 %1
series y={%depvar_adf}
!flag_adf=1

equation eq_ADF1 
eq_ADF1.ls d(y) y(-1) d(y(-1)) d(y(-2)) d(y(-3)) d(y(-4)) c @trend

equation eq_ADF2
eq_ADF2.ls d(y,2) d(y(-1)) d(y(-1),2) d(y(-2),2) d(y(-3),2) d(y(-4),2) c @trend	

'%5 significance level
if eq_ADF1.@tstats(1)<-3.229230 then 

'if abs(eq_ADF1.@coefs(1))<abs(eq_ADF2.@coefs(1)) or eq_ADF1.@coefs(1)<-3.229230 then 
	!flag_adf=0
endif

scalar differencing=!flag_adf

'smpl %0 %1
endsub







'**************************************************************************************************
'*********STATE SPACE MODELS: TIME VARYING INTERCEPTS  ********************
'**************************************************************************************************

'THIS PROGRAM ESTIMATES VAR MODEL
'USING SS APPROACH
'INTERCEPTS ARE ASSUMED TO BE TIME VARYING

'EACH EQATUION IN VAR IS ESTIMATED SEPRATELY
'TO SPEED UP ESTIMATION. LOSS IN EFFICIENCY IS NOT LARGE

subroutine run_ss_models (string %start_date_SSX, string %end_date_SSX, scalar VAR_OrderSS, scalar SS_forec_horizon, scalar SS_exo, string %5, string %country_suffix)

'the order of the variables
'startting date (string)
'ending date (string)
'order of the VAR (number)
'forecast horizon (number)
'number of exogenous variables (number)
'transformed text for exogenous series (like "c(50)*dlog(rgdp_euf)+c(51)*dlog(ex_eurousdf,0,4)")  (string)


statusline RUNNING SS MODELS

'Define starting date
%start_date_SS=%start_date_SSX

'Define end date
%end_date_SS=%end_date_SSX


'Define lag (order of the 
'!var_order=@val(%2)
!var_order=VAR_OrderSS

'Define forecast horizon
'!hh=@val(%3)
!hh=SS_forec_horizon


smpl %end_date_SS+1 %end_date_SS+!hh

'define the number of exogenous series 
scalar exo_var_num=SS_exo '@val(%4)

'Define exogenous variables
%exo_transformed=%5

'country suffix
'%country_suffix=%6

'End date

scalar var_order=!var_order

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'DEFINITIONS
'%end_date_SS="2001:4"
'%start_date_SS="1995:1"

'order of the VAR
'!p=2
!p=VAR_order

'number of endogenosu variables
!m=5
'!m=endo_var_num

'number of exogenous variables
'!exovar=2
'!exovar=exo_var_num

'define country suffixes
'%country_suffix="hun"
%suf="_"+%country_suffix

'Set of endogenous variables
%endo_v1="rgdp"+%suf
%endo_v2="unemplilo"+%suf
%endo_v3="cpi"+%suf
%endo_v4="exeuro"+%suf
%endo_v5="m2"+%suf

%exo_transformed="c(50)*dlog(rgdp_euf)+c(51)*dlog(ex_eurousdf,0,4)"

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if @isobject("var_ss01") then
	delete var_ss01
endif

if @isobject("var_ss02") then
	delete var_ss02
endif

if @isobject("var_ss03") then
	delete var_ss03
endif

if @isobject("var_ss04") then
	delete var_ss04
endif

if @isobject("var_ss05") then
	delete var_ss05
endif

'list of variables to exclude: state spaces
if @isobject("exclude") then
	delete exclude
endif

call create_strings

delete model_ss0*



call equation1

call equation2
call equation3
call equation4
call equation5

'delete model_ss0*

if @isobject("model_final") then
	delete model_final
endif


model model_final

for !i=1 to !m
model_final.merge model_ss0{!i}
next

'show model_final
model_final.scenario "Scenario 1"
model_final.exclude sv1 sv2 sv3 sv4 sv5
smpl %end_date_SS+1 %end_date_SS+!hh
model_final.solveopt(s=s)
model_final.solve

if @isobject("xxx") then
	delete xxx
endif

group xxx *{%suf}_1*
'show xxx



genr {%endo_v1}_SS={%endo_v1}_1m
genr {%endo_v2}_SS={%endo_v2}_1m
genr {%endo_v3}_SS={%endo_v3}_1m
genr {%endo_v4}_SS={%endo_v4}_1m
genr {%endo_v5}_SS={%endo_v5}_1m

genr {%endo_v1}_SS_SE={%endo_v1}_1s
genr {%endo_v2}_SS_SE={%endo_v2}_1s
genr {%endo_v3}_SS_SE={%endo_v3}_1s
genr {%endo_v4}_SS_SE={%endo_v4}_1s
genr {%endo_v5}_SS_SE={%endo_v5}_1s




endsub

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
subroutine create_strings
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%str01=" "

'for !i=1 to !p*!m

'RGDP
%str01="DLOG("+%endo_v1+",0,4) = C(1)*DLOG("+%endo_v1+"(-1),0,4) + C(2)*DLOG("+%endo_v1+"(-2),0,4) + C(3)*D("+%endo_v2+"(-1)) + C(4)*D("+%endo_v2+"(-2),0,4) + C(5)*DLOG("+%endo_v3+"(-1),1,4) + C(6)*DLOG("+%endo_v3+"(-2),1,4) + C(7)*DLOG("+%endo_v4+"(-1),1,4) + C(8)*DLOG("+%endo_v4+"(-2),1,4) + C(9)*DLOG("+%endo_v5+"(-1)) + C(10)*DLOG("+%endo_v5+"(-2)) + sv1+" + %exo_transformed+"+[var=exp(c(200))]"



%str01OLS="DLOG("+%endo_v1+",0,4) = C(1)*DLOG("+%endo_v1+"(-1),0,4) + C(2)*DLOG("+%endo_v1+"(-2),0,4) + C(3)*D("+%endo_v2+"(-1)) + C(4)*D("+%endo_v2+"(-2),0,4) + C(5)*DLOG("+%endo_v3+"(-1),1,4) + C(6)*DLOG("+%endo_v3+"(-2),1,4) + C(7)*DLOG("+%endo_v4+"(-1),1,4) + C(8)*DLOG("+%endo_v4+"(-2),1,4) + C(9)*DLOG("+%endo_v5+"(-1)) + C(10)*DLOG("+%endo_v5+"(-2)) + c(100)+" + %exo_transformed



'Unemployment 
%str02="D("+%endo_v2+",0,4) = C(1)*DLOG("+%endo_v1+"(-1),0,4) + C(2)*DLOG("+%endo_v1+"(-2),0,4) + C(3)*D("+%endo_v2+"(-1)) + C(4)*D("+%endo_v2+"(-2),0,4) + C(5)*DLOG("+%endo_v3+"(-1),1,4) + C(6)*DLOG("+%endo_v3+"(-2),1,4) + C(7)*DLOG("+%endo_v4+"(-1),1,4) + C(8)*DLOG("+%endo_v4+"(-2),1,4) + C(9)*DLOG("+%endo_v5+"(-1)) + C(10)*DLOG("+%endo_v5+"(-2))  + sv2+" + %exo_transformed+"+[var=exp(c(200))]"

%str02OLS="D("+%endo_v2+",0,4) = C(1)*DLOG("+%endo_v1+"(-1),0,4) + C(2)*DLOG("+%endo_v1+"(-2),0,4) + C(3)*D("+%endo_v2+"(-1)) + C(4)*D("+%endo_v2+"(-2),0,4) + C(5)*DLOG("+%endo_v3+"(-1),1,4) + C(6)*DLOG("+%endo_v3+"(-2),1,4) + C(7)*DLOG("+%endo_v4+"(-1),1,4) + C(8)*DLOG("+%endo_v4+"(-2),1,4) + C(9)*DLOG("+%endo_v5+"(-1)) + C(10)*DLOG("+%endo_v5+"(-2)) + c(100)+" + %exo_transformed


'CPI
%str03="DLOG("+%endo_v3+",0,4) = C(1)*DLOG("+%endo_v1+"(-1),0,4) + C(2)*DLOG("+%endo_v1+"(-2),0,4) + C(3)*D("+%endo_v2+"(-1)) + C(4)*D("+%endo_v2+"(-2),0,4) + C(5)*DLOG("+%endo_v3+"(-1),1,4) + C(6)*DLOG("+%endo_v3+"(-2),1,4) + C(7)*DLOG("+%endo_v4+"(-1),1,4) + C(8)*DLOG("+%endo_v4+"(-2),1,4) + C(9)*DLOG("+%endo_v5+"(-1)) + C(10)*DLOG("+%endo_v5+"(-2)) + sv3+" + %exo_transformed+"+[var=exp(c(200))]"

%str03OLS="DLOG("+%endo_v3+",0,4) = C(1)*DLOG("+%endo_v1+"(-1),0,4) + C(2)*DLOG("+%endo_v1+"(-2),0,4) + C(3)*D("+%endo_v2+"(-1)) + C(4)*D("+%endo_v2+"(-2),0,4) + C(5)*DLOG("+%endo_v3+"(-1),1,4) + C(6)*DLOG("+%endo_v3+"(-2),1,4) + C(7)*DLOG("+%endo_v4+"(-1),1,4) + C(8)*DLOG("+%endo_v4+"(-2),1,4) + C(9)*DLOG("+%endo_v5+"(-1)) + C(10)*DLOG("+%endo_v5+"(-2)) + c(100)+" + %exo_transformed


'Exchange rate
%str04="Dlog("+%endo_v4+",0,4) = C(1)*DLOG("+%endo_v1+"(-1),0,4) + C(2)*DLOG("+%endo_v1+"(-2),0,4) + C(3)*D("+%endo_v2+"(-1)) + C(4)*D("+%endo_v2+"(-2),0,4) + C(5)*DLOG("+%endo_v3+"(-1),1,4) + C(6)*DLOG("+%endo_v3+"(-2),1,4) + C(7)*DLOG("+%endo_v4+"(-1),1,4) + C(8)*DLOG("+%endo_v4+"(-2),1,4) + C(9)*DLOG("+%endo_v5+"(-1)) + C(10)*DLOG("+%endo_v5+"(-2)) + sv4+" + %exo_transformed+"+[var=exp(c(200))]"

%str04OLS="DLOG("+%endo_v4+",0,4) = C(1)*DLOG("+%endo_v1+"(-1),0,4) + C(2)*DLOG("+%endo_v1+"(-2),0,4) + C(3)*D("+%endo_v2+"(-1)) + C(4)*D("+%endo_v2+"(-2),0,4) + C(5)*DLOG("+%endo_v3+"(-1),1,4) + C(6)*DLOG("+%endo_v3+"(-2),1,4) + C(7)*DLOG("+%endo_v4+"(-1),1,4) + C(8)*DLOG("+%endo_v4+"(-2),1,4) + C(9)*DLOG("+%endo_v5+"(-1)) + C(10)*DLOG("+%endo_v5+"(-2)) + c(100)+" + %exo_transformed


'M2
%str05="DLOG("+%endo_v5+",0,4) = C(1)*DLOG("+%endo_v1+"(-1),0,4) + C(2)*DLOG("+%endo_v1+"(-2),0,4) + C(3)*D("+%endo_v2+"(-1)) + C(4)*D("+%endo_v2+"(-2),0,4) + C(5)*DLOG("+%endo_v3+"(-1),1,4) + C(6)*DLOG("+%endo_v3+"(-2),1,4) + C(7)*DLOG("+%endo_v4+"(-1),1,4) + C(8)*DLOG("+%endo_v4+"(-2),1,4) + C(9)*DLOG("+%endo_v5+"(-1)) + C(10)*DLOG("+%endo_v5+"(-2)) + sv5+" + %exo_transformed+"+[var=exp(c(200))]"

%str05OLS="DLOG("+%endo_v5+",0,4) = C(1)*DLOG("+%endo_v1+"(-1),0,4) + C(2)*DLOG("+%endo_v1+"(-2),0,4) + C(3)*D("+%endo_v2+"(-1)) + C(4)*D("+%endo_v2+"(-2),0,4) + C(5)*DLOG("+%endo_v3+"(-1),1,4) + C(6)*DLOG("+%endo_v3+"(-2),1,4) + C(7)*DLOG("+%endo_v4+"(-1),1,4) + C(8)*DLOG("+%endo_v4+"(-2),1,4) + C(9)*DLOG("+%endo_v5+"(-1)) + C(10)*DLOG("+%endo_v5+"(-2)) + c(100)+" + %exo_transformed

'random-walk intercept
%str_sv01="@state sv1=sv1(-1)+[var=exp(c(300))]"
%str_sv02="@state sv2=sv2(-1)+[var=exp(c(300))]"
%str_sv03="@state sv3=sv3(-1)+[var=exp(c(300))]"
%str_sv04="@state sv4=sv4(-1)+[var=exp(c(300))]"
%str_sv05="@state sv5=sv5(-1)+[var=exp(c(300))]"


endsub

'==============================================

subroutine equation1


sspace var_ss01


var_ss01.append {%str01}


var_ss01.append {%str_sv01}

'estimate LS equation to get starting values


equation temp01 {%str01OLS}
smpl @all
temp01.ls {%str01OLS}



'define the vector of priors
if @isobject("m01") then
	delete m01
endif

vector(1) m01
m01(1)=temp01.@coefs(!m*!p+1)


'define covariance matrix for state spaces
if @isobject("v01") then
	delete v01
endif

sym(1) v01
v01(1,1)=1 'temp01.@se^2


'var_ss01.append @mprior m01
'var_ss01.append @vprior v01

'define coefficients for SSpace
c(1)=temp01.@coefs(1)
c(2)=temp01.@coefs(2)
c(3)=temp01.@coefs(3)
c(4)=temp01.@coefs(4)
c(5)=temp01.@coefs(5)
c(6)=temp01.@coefs(6)
c(7)=temp01.@coefs(7)
c(8)=temp01.@coefs(8)
c(9)=temp01.@coefs(9)
c(10)=temp01.@coefs(10)

c(200)=log(temp01.@se^2/2)

c(300)=log(temp01.@se^2/2)

smpl %start_date_SS %end_date_SS



var_ss01.ml

'create filtered states

if @isobject("ss_ss01") then 
	delete ss_ss01
endif




vector ss_ss01=var_ss01.@sm_state	
!last_state=(ss_ss01(@rows(ss_ss01))+ss_ss01(@rows(ss_ss01)-1))/2
mtos(ss_ss01,sv1)

smpl %end_date_SS+1 @last
series sv1=!last_state

if @isobject("model_ss01") then
	delete model_ss01
endif

var_ss01.makemodel(model_ss01)
model_ss01.scenario "Scenario 1"


endsub


'==========================================

subroutine equation2


sspace var_ss02
var_ss02.append {%str02}
var_ss02.append {%str_sv02}

'estimate LS equation to get starting values
equation temp02 

smpl @all
temp02.ls {%str02OLS}


'define the vector of priors
if @isobject("m02") then
	delete m02
endif

vector(1) m02
m02(1)=temp02.@coefs(!m*!p+1)


'define covariance matrix for state spaces
if @isobject("v02") then
	delete v02
endif

sym(1) v02
v02(1,1)=1 'temp02.@se^2


'var_ss02.append @mprior m02
'var_ss02.append @vprior v02

'define coefficients for SSpace
c(1)=temp02.@coefs(1)
c(2)=temp02.@coefs(2)
c(3)=temp02.@coefs(3)
c(4)=temp02.@coefs(4)
c(5)=temp02.@coefs(5)
c(6)=temp02.@coefs(6)
c(7)=temp02.@coefs(7)
c(8)=temp02.@coefs(8)
c(9)=temp02.@coefs(9)
c(10)=temp02.@coefs(10)

c(200)=log(temp02.@se^2/2)

c(300)=log(temp02.@se^2/2)

smpl %start_date_SS %end_date_SS

var_ss02.ml

vector ss_ss02=var_ss02.@sm_state	
!last_state=(ss_ss02(@rows(ss_ss02))+ss_ss02(@rows(ss_ss02)-1))/2
mtos(ss_ss02,sv2)

smpl %end_date_SS+1 @last
series sv2=!last_state

var_ss02.makemodel(model_ss02)


endsub

'====================================

subroutine equation3


sspace var_ss03
var_ss03.append {%str03}
var_ss03.append {%str_sv03}

'estimate LS equation to get starting values
equation temp03 

smpl @all
temp03.ls {%str03OLS}


'define the vector of priors
if @isobject("m03") then
	delete m03
endif

vector(1) m03
m01(1)=temp03.@coefs(!m*!p+1)


'define covariance matrix for state spaces
if @isobject("v03") then
	delete v03
endif

sym(1) v03
v03(1,1)=1 'temp03.@se^2


'var_ss03.append @mprior m03
'var_ss03.append @vprior v03

'define coefficients for SSpace
c(1)=temp03.@coefs(1)
c(2)=temp03.@coefs(2)
c(3)=temp03.@coefs(3)
c(4)=temp03.@coefs(4)
c(5)=temp03.@coefs(5)
c(6)=temp03.@coefs(6)
c(7)=temp03.@coefs(7)
c(8)=temp03.@coefs(8)
c(9)=temp03.@coefs(9)
c(10)=temp03.@coefs(10)

c(200)=log(temp03.@se^2/2)

c(300)=log(temp03.@se^2/2)

smpl %start_date_SS %end_date_SS

var_ss03.ml

vector ss_ss03=var_ss03.@sm_state	
!last_state=(ss_ss03(@rows(ss_ss03))+ss_ss03(@rows(ss_ss03)-1))/2
mtos(ss_ss03,sv3)

smpl %end_date_SS+1 @last
series sv3=!last_state

var_ss03.makemodel(model_ss03)

endsub

'===================================

subroutine equation4


sspace var_ss04
var_ss04.append {%str04}
var_ss04.append {%str_sv04}

'estimate LS equation to get starting values
equation temp04 

smpl @all
temp04.ls {%str04OLS}


'define the vector of priors
if @isobject("m04") then
	delete m04
endif

vector(1) m04
m01(1)=temp04.@coefs(!m*!p+1)


'define covariance matrix for state spaces
if @isobject("v04") then
	delete v04
endif

sym(1) v04
v04(1,1)=1 'temp04.@se^2


'var_ss04.append @mprior m04
'var_ss04.append @vprior v04

'define coefficients for SSpace
c(1)=temp04.@coefs(1)
c(2)=temp04.@coefs(2)
c(3)=temp04.@coefs(3)
c(4)=temp04.@coefs(4)
c(5)=temp04.@coefs(5)
c(6)=temp04.@coefs(6)
c(7)=temp04.@coefs(7)
c(8)=temp04.@coefs(8)
c(9)=temp04.@coefs(9)
c(10)=temp04.@coefs(10)

c(200)=log(temp04.@se^2/2)

c(300)=log(temp04.@se^2/2)

smpl %start_date_SS %end_date_SS

var_ss04.ml

vector ss_ss04=var_ss04.@sm_state	
!last_state=(ss_ss04(@rows(ss_ss04))+ss_ss04(@rows(ss_ss04)-1))/2
mtos(ss_ss04,sv4)

smpl %end_date_SS+1 @last
series sv4=!last_state

var_ss04.makemodel(model_ss04)

endsub


'=====================================

subroutine equation5


sspace var_ss05
var_ss05.append {%str05}
var_ss05.append {%str_sv05}

'estimate LS equation to get starting values
equation temp05 

smpl @all
temp05.ls {%str05OLS}


'define the vector of priors
if @isobject("m05") then
	delete m05
endif

vector(1) m05
m01(1)=temp05.@coefs(!m*!p+1)


'define covariance matrix for state spaces
if @isobject("v05") then
	delete v05
endif

sym(1) v05
v05(1,1)=1 'temp05.@se^2


'var_ss05.append @mprior m05
'var_ss05.append @vprior v05

'define coefficients for SSpace
c(1)=temp05.@coefs(1)
c(2)=temp05.@coefs(2)
c(3)=temp05.@coefs(3)
c(4)=temp05.@coefs(4)
c(5)=temp05.@coefs(5)
c(6)=temp05.@coefs(6)
c(7)=temp05.@coefs(7)
c(8)=temp05.@coefs(8)
c(9)=temp05.@coefs(9)
c(10)=temp05.@coefs(10)

c(200)=log(temp05.@se^2/2)

c(300)=log(temp05.@se^2)/3

if @isobject("x") then
	delete x
endif 
scalar x=log(temp05.@se^2)/3

smpl %start_date_SS %end_date_SS

var_ss05.ml

'matrix(1,1)  xxx=var_ss05.@coefcov	
'sm_stateerrstd

vector ss_ss05=var_ss05.@sm_state	
!last_state=(ss_ss05(@rows(ss_ss05))+ss_ss05(@rows(ss_ss05)-1))/2
mtos(ss_ss05,sv5)

smpl %end_date_SS+1 @last
series sv5=!last_state

var_ss05.makemodel(model_ss05)


endsub

'============================================================
subroutine EIU_forecs

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'consumer price index
smpl %date_global_start %date_global_end
%str_cpi="dlog(cpi_"+%thesuffix+",0,4)*100 c dlog(cpi_"+%thesuffix+"(-1),0,4)*100 dlog(cpi_"+%thesuffix+"(-2),0,4)*100 inf_eium1 inf_eiu0 inf_eiu1"+%exo_eiu
equation _eq_temp_cpi.ls {%str_cpi}


smpl %date_global_end+1 %date_global_forecast
_eq_temp_cpi.forecast cpi_{%thesuffix}_eiu cpi_{%thesuffix}_eiu_se

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'real GDP 
smpl %date_global_start %date_global_end
%str_rgdp="dlog(rgdp_"+%thesuffix+",0,4)*100 c dlog(rgdp_"+%thesuffix+"(-1),0,4)*100 dlog(rgdp_"+%thesuffix+"(-2),0,4)*100 rgdp_eium1 rgdp_eiu0 rgdp_eiu1"+%exo_eiu
equation _eq_temp_rgdp.ls {%str_rgdp}

smpl %date_global_end+1 %date_global_forecast
_eq_temp_rgdp.forecast rgdp_{%thesuffix}_eiu rgdp_{%thesuffix}_eiu_se

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

'USD exchange rate 
smpl %date_global_start %date_global_end
%str_exusd="exusd_"+%thesuffix+" c exusd_"+%thesuffix+"(-1) exusd_"+%thesuffix+"(-2) exusd_eium1 exusd_eiu0 exusd_eiu1"+%exo_eiu
equation _eq_temp_exusd.ls {%str_exusd}

smpl %date_global_end+1 %date_global_forecast
_eq_temp_exusd.forecast exusd_{%thesuffix}_eiu exusd_{%thesuffix}_eiu_se

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

'Registered unemployment rate
smpl %date_global_start %date_global_end
%str_unemplilo="unemplreg_"+%thesuffix+" c unemplreg_"+%thesuffix+"(-1) unemplreg_"+%thesuffix+"(-2) unemplilo_eium1/100 unemplilo_eiu0/100 unemplilo_eiu1/100" +%exo_eiu
equation _eq_temp_unemplilo.ls {%str_unemplilo}

smpl %date_global_end+1 %date_global_forecast
_eq_temp_unemplilo.forecast unemplreg_{%thesuffix}_eiu unemplreg_{%thesuffix}_eiu_se

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

'ILO unemployment rate

smpl %date_global_start %date_global_end
%str_check_ilo="unemplilo_eiu0"
if @isobject(%str_check_ilo) then 
	%str_unemplilo="unemplilo_"+%thesuffix+" c unemplilo_"+%thesuffix+"(-1) unemplilo_"+%thesuffix+"(-2) unemplilo_eium1/100 unemplilo_eiu0/100 unemplilo_eiu1/100" +%exo_eiu
	equation _eq_temp_unemplilo.ls {%str_unemplilo}

else
	%str_unemplilo="unemplilo_"+%thesuffix+" c unemplilo_"+%thesuffix+"(-1) unemplilo_"+%thesuffix+"(-2) unemplilo_eium1/100 unemplilo_eiu0/100 unemplilo_eiu1/100" +%exo_eiu
	equation _eq_temp_unemplilo.ls {%str_unemplilo}
endif

	smpl %date_global_end+1 %date_global_forecast
	_eq_temp_unemplilo.forecast unemplilo_{%thesuffix}_eiu unemplilo_{%thesuffix}_eiu_se

endsub

'============================================================
subroutine OECD_forecs
'============================================================

%exo_oecd=" "
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'consumer price index
smpl %date_global_start %date_global_end
%str_cpi="dlog(cpi_"+%thesuffix+",0,4)*100 c dlog(cpi_"+%thesuffix+"(-1),0,4)*100 dlog(cpi_"+%thesuffix+"(-2),0,4)*100 inf_oecdm1 INF_OECD0 inf_oecd1"+%exo_oecd
equation _eq_temp_cpi.ls {%str_cpi}


smpl %date_global_end+1 %date_global_forecast
_eq_temp_cpi.forecast cpi_{%thesuffix}_oecd cpi_{%thesuffix}_oecd_se

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'real GDP 
smpl %date_global_start %date_global_end
%str_rgdp="dlog(rgdp_"+%thesuffix+",0,4)*100 c dlog(rgdp_"+%thesuffix+"(-1),0,4)*100 dlog(rgdp_"+%thesuffix+"(-2),0,4)*100 rgdp_oecdm1 rgdp_oecd0 rgdp_oecd1"+%exo_oecd
equation _eq_temp_rgdp.ls {%str_rgdp}

smpl %date_global_end+1 %date_global_forecast
_eq_temp_rgdp.forecast rgdp_{%thesuffix}_oecd rgdp_{%thesuffix}_oecd_se

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

'Registered unemployment rate
smpl %date_global_start %date_global_end
%str_unemplilo="unemplreg_"+%thesuffix+" c unemplreg_"+%thesuffix+"(-1) unemplreg_"+%thesuffix+"(-2) unemplilo_oecdm1/100 unemplilo_oecd0/100 unemplilo_oecd1/100" +%exo_oecd
equation _eq_temp_unemplilo.ls {%str_unemplilo}

smpl %date_global_end+1 %date_global_forecast
_eq_temp_unemplilo.forecast unemplreg_{%thesuffix}_oecd unemplreg_{%thesuffix}_oecd_se

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

'ILO unemployment rate

smpl %date_global_start %date_global_end
%str_check_ilo="unemplilo_oecd0"
if @isobject(%str_check_ilo) then 
	%str_unemplilo="unemplilo_"+%thesuffix+" c unemplilo_"+%thesuffix+"(-1) unemplilo_"+%thesuffix+"(-2) unemplilo_oecdm1/100 unemplilo_oecd0/100 unemplilo_oecd1/100" +%exo_oecd
	equation _eq_temp_unemplilo.ls {%str_unemplilo}

else
	%str_unemplilo="unemplilo_"+%thesuffix+" c unemplilo_"+%thesuffix+"(-1) unemplilo_"+%thesuffix+"(-2) unemplilo_oecdm1/100 unemplilo_oecd0/100 unemplilo_oecd1/100" +%exo_oecd
	equation _eq_temp_unemplilo.ls {%str_unemplilo}
endif

	smpl %date_global_end+1 %date_global_forecast
	_eq_temp_unemplilo.forecast unemplilo_{%thesuffix}_oecd unemplilo_{%thesuffix}_oecd_se

endsub



'**************************************************************************************************
' ***********************  DISCOUNTED LS ******************************************************
'**************************************************************************************************

subroutine DISCOUNT_LS (string %disc_dep_var, string %disc_end_date, string %disc_last_forec_date, string %disc_list_exo_var, string %2)

'maximum discounting
!wmax=1.15

'ste in the search of discounting
!wstep=0.01

'horizon selection
!hor_slct=12

%disc_dep_var_net=%2

smpl @all
genr y={%disc_dep_var}
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'start iterations: search for MSE-best dicounting factor
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
smpl @all
!minsumsq=@var(y)*1e50
!maxj=1
matrix(100,3) _results
_results.fill(L) 0

'%dat_dsic_temp=
	for !j=1 to !wmax step !wstep

	statusline Iteration # !j

		'compute weights	
		smpl @all
		genr w1=!j^@trend

		'choose estimation sample
		%disc_est_sample=@otod(@dtoo(%disc_end_date)-4)
		smpl @first %disc_est_sample
		


		!disc_SIC_max=-100000
		!maxlag_disc=1
		%str_spec_disc=%disc_dep_var+" c "
		for !k_disc_select=1 to 6
			%str_spec_disc=%str_spec_disc+" y(-"+@str(!k_disc_select)+") "
			%disc_spec1=%str_spec_disc+" "+%disc_list_exo_var


			equation eq02.ls(w=w1) {%disc_spec1} '%str_spec_disc %disc_list_exo_var
			if  eq02.@schwarz>!disc_SIC_max then 
					!disc_SIC_max=eq02.@schwarz
					!maxlag_disc=!k_disc_select
			endif
		next
		
		%str_spec_disc=%disc_dep_var+" c "
		for !k_disc_select=1 to !maxlag_disc
			%str_spec_disc=%str_spec_disc+" y(-"+@str(!k_disc_select)+") "
		next
		%disc_spec1=%str_spec_disc+" "+%disc_list_exo_var

		equation eq02.ls(w=w1) {%disc_spec1} '%str_spec_disc %disc_list_exo_var

		%disc_smpl1=%disc_est_sample+" "+%disc_end_date

		smpl {%disc_smpl1}


		if @isobject("model_disc_est") then 
			delete model_disc_est
		endif
		
		eq02.makemodel(model_disc_est)
	
		%str_disc_append_est="y="+%disc_dep_var
		model_disc_est.append {%str_disc_append_est}
		model_disc_est.scenario baseline
		model_disc_est.solve(s=d) 


		genr y_wls={%disc_dep_var_net}_0


		!smsq=0
		genr __disc_diff=y_wls-{%disc_dep_var}
		!smsq=@stdev(__disc_diff)

		if 	!smsq<!minsumsq then 
			!maxj=!j
			!minsumsq=!smsq
		endif

		_results((!j-1)*100+1,1)=!j
		_results((!j-1)*100+1,2)=!smsq
		_results((!j-1)*100+1,3)=!disc_SIC_max


'		delete y_wls
	next '!j

statusline CHECKIT
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' produce forecast

	'generate weight minimizing MSE
		'compute weights	
		smpl @all
		genr w1=!maxj^@trend

	'reestimate optimal model with optimal lag selection
		smpl @first %disc_end_date
		!disc_SIC_max=-100000
		!maxlag_disc=1
		%str_spec_disc=%disc_dep_var+" c "
		for !k_disc_select=1 to 6
			%str_spec_disc=%str_spec_disc+" y(-"+@str(!k_disc_select)+") "
		%disc_spec1=%str_spec_disc+" "+%disc_list_exo_var



			equation eq02.ls(w=w1) {%disc_spec1} ' %str_spec_disc %disc_list_exo_var
			if  eq02.@schwarz>!disc_SIC_max then 
					!disc_SIC_max=eq02.@schwarz
					!maxlag_disc=!k_disc_select
			endif
		next
		
		%str_spec_disc= %disc_dep_var+" c "
		for !k_disc_select=1 to !maxlag_disc
			%str_spec_disc=%str_spec_disc+" y(-"+@str(!k_disc_select)+") "
		next
		%disc_spec1=%str_spec_disc+" "+%disc_list_exo_var


		equation eq02.ls(w=w1) {%disc_spec1} ' %str_spec_disc %disc_list_exo_var

		
		'compute forecast
		%disc_end_date1=@otod(@dtoo(%disc_end_date)+1)
		%disk_sample2=%disc_end_date1+" "+%disc_last_forec_date
		smpl {%disk_sample2} '%disc_end_date1 @last '%disc_last_forec_date
		
		if @isobject("model_disc") then 
			delete model_disc
		endif
		
		eq02.makemodel(model_disc)
	
		%str_disc_append="y="+%disc_dep_var
		model_disc.append {%str_disc_append }
		model_disc.scenario baseline
		model_disc.solve(s=s) 

		smpl @all
		genr {%disc_dep_var_net}_wls={%disc_dep_var_net}_0m
		genr {%disc_dep_var_net}_wls_SE={%disc_dep_var_net}_0s



smpl @all

endsub


'**************************************************************************************************
' **********************              IMPORT DATA FROM EXCEL     ********************************
'**************************************************************************************************

subroutine IMPORT_DATA

%filename_to_import="C:\final2cd\description\DATA\recent-to-import\"+%thesuffix+".xls"


%str_start_cell="B5"

'number of series to be imported
!ser_N_2import=49

'name of the spreadsheet to import
%str_spreadsheet=%thesuffix+"_QM"
smpl 1989:01 @last

delete ser??

read(t=xls,{%str_start_cell},s={%str_spreadsheet}) %filename_to_import !ser_N_2import

'update key national series 
series rgdp_{%thesuffix}=na
series rgdp_{%thesuffix}=ser07

series cpi_{%thesuffix}=na
series cpi_{%thesuffix}=ser14

series unemplilo_{%thesuffix}=na
series unemplilo_{%thesuffix}=ser21

series unemplreg_{%thesuffix}=na
series unemplreg_{%thesuffix}=ser28

series exusd_{%thesuffix}=na
series exusd_{%thesuffix}=ser35

series exeuro_{%thesuffix}=na
series exeuro_{%thesuffix}=ser42

series m2_{%thesuffix}=na
series m2_{%thesuffix}=ser49


'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'IMPORT INTERNATIONAL SERIES AND ASSUMPTIONS


read(t=xls,B3,s=AGGREGATE_Q) "C:\final2cd\description\DATA\international_data.xls"  rgdp_EU	cpi_EU	ex_eurousd	OIL_US

smpl @all
genr rgdp_EUf=rgdp_EU
genr cpi_EUf=cpi_EU
genr ex_eurousdf=ex_eurousd
genr OIL_USf=OIL_US

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'IMPORT EIU  FORECASTS 

delete *eiu*
smpl 1996:1 @last

%str_EIU_import=%thesuffix+"_EIU"
%str_EIU_FILE_NAME="C:\final2cd\description\DATA\recent-to-import\"+%thesuffix+".xls"
read(t=xls,B4,s={%str_EIU_import}) %str_EIU_FILE_NAME  INF_EIUM1 INF_EIU0 INF_EIU1 INF_EIU2 INF_EIU3 RGDP_EIUM1 RGDP_EIU0 RGDP_EIU1 RGDP_EIU2 RGDP_EIU3 EXUSD_EIUM1 EXUSD_EIU0 EXUSD_EIU1 EXUSD_EIU2 EXUSD_EIU3 EXEURO_EIUM1 EXEURO_EIU0 EXEURO_EIU1 EXEURO_EIU2 EXEURO_EIU3 UNEMPLILO_EIUM1 UNEMPLILO_EIU0 UNEMPLILO_EIU1 UNEMPLILO_EIU2 UNEMPLILO_EIU3



delete ser??


'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'IMPORT OECD FORECASTS 

delete *oecd*
smpl 1998:1 @last

%str_oecd_import=%thesuffix+"_oecd"
%str_oecd_FILE_NAME="C:\final2cd\description\DATA\recent-to-import\"+%thesuffix+".xls"
statusline %str_oecd_FILE_NAME
read(t=xls,B4,s={%str_oecd_import}) %str_oecd_FILE_NAME  INF_OECDM1 INF_OECD0  INF_OECD1 INF_OECD2 INF_OECD3  RGDP_OECDM1  RGDP_OECD0  RGDP_OECD1 RGDP_OECD2 RGDP_OECD3 UNEMPLILO_OECDM1 UNEMPLILO_OECD0 UNEMPLILO_OECD1 UNEMPLILO_OECD2 UNEMPLILO_OECD3


delete ser??

endsub


'**************************************************************************************************
'******************************    DETREND SERIES *********************************************
'**************************************************************************************************

subroutine DETREND_SERIES

'this subroutine detrends all series 
smpl @all

rgdp_{%thesuffix}.x12(mode=m, save=" d10 d11") rgdp_{%thesuffix} 

m2_{%thesuffix}.x12(mode=m, save=" d10 d11") m2_{%thesuffix} 

cpi_{%thesuffix}.x12(mode=m, save=" d10 d11") cpi_{%thesuffix} 

exeuro_{%thesuffix}.x12(mode=m, save=" d10 d11") exeuro_{%thesuffix} 

exusd_{%thesuffix}.x12(mode=m, save=" d10 d11") exusd_{%thesuffix} 

unemplreg_{%thesuffix}.x12(mode=a, save=" d10 d11") unemplreg_{%thesuffix} 

unemplilo_{%thesuffix}.x12(mode=a, save=" d10 d11") unemplilo_{%thesuffix} 

'detrending is performed till the last observation extend seasonal pattern
'for all subseqeunt periods

smpl %date_global_end @last
genr rgdp_{%thesuffix}_sf=rgdp_{%thesuffix}_sf(-4)
genr m2_{%thesuffix}_sf=m2_{%thesuffix}_sf(-4)
genr cpi_{%thesuffix}_sf=cpi_{%thesuffix}_sf(-4)
genr exeuro_{%thesuffix}_sf=exeuro_{%thesuffix}_sf(-4)
genr exusd_{%thesuffix}_sf=exusd_{%thesuffix}_sf(-4)
genr unemplreg_{%thesuffix}_sf=unemplreg_{%thesuffix}_sf(-4)
genr unemplilo_{%thesuffix}_sf=unemplilo_{%thesuffix}_sf(-4)


endsub

